# When run will fully give a random power to a player.
function osp:api/reset_superpower

tag @s remove Selected

execute unless score @s osp.ElderTimer matches 1.. if score Eldritch osp.RarityCount < EldritchLimit osp.settings if predicate osp:randomizer/join/eldritch run function osp:systems/randomizer/selection/eldritch
execute if score Epic osp.RarityCount < EpicLimit osp.settings unless entity @s[tag=Selected] if predicate osp:randomizer/join/epic run function osp:systems/randomizer/selection/epic
execute if score Rare osp.RarityCount < RareLimit osp.settings unless entity @s[tag=Selected] if predicate osp:randomizer/join/rare run function osp:systems/randomizer/selection/rare
execute if score Uncommon osp.RarityCount < UncommonLimit osp.settings unless entity @s[tag=Selected] if predicate osp:randomizer/join/uncommon run function osp:systems/randomizer/selection/uncommon
execute if score Common osp.RarityCount < CommonLimit osp.settings unless entity @s[tag=Selected] run function osp:systems/randomizer/join/common

tag @s remove Selected

## Power Tracking
function #osp:gain_superpower

## Effects
## Elderitch
execute if entity @s[tag=osp.rarity.eldritch] run particle minecraft:totem_of_undying ~ ~ ~ 0 0 0 1 1000
execute if entity @s[tag=osp.rarity.eldritch] run particle minecraft:explosion_emitter ~ ~ ~
execute if entity @s[tag=osp.rarity.eldritch] run playsound minecraft:entity.wither.spawn master @a ~ ~ ~ 0.25 0 0.25

execute if entity @s[tag=osp.rarity.eldritch] run execute if predicate osp:randomizer/50 run tag @s add A

execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=A] if predicate osp:randomizer/50 run tag @s add AA
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=A,tag=!AA] run tag @s add AB


execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=!A] if predicate osp:randomizer/50 run tag @s add BA
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=!A,tag=!BA] run tag @s add BB

execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=AA] run tellraw @s ["",{"text":"You have gained a "},{"text":"El","color":"dark_purple"},{"text":"d","obfuscated":true,"color":"dark_purple"},{"text":"rit","color":"dark_purple"},{"text":"c","obfuscated":true,"color":"dark_purple"},{"text":"h","color":"dark_purple"},{"text":" superpower!"}]
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=AB] run tellraw @s ["",{"text":"You have gained a "},{"text":"E","color":"dark_purple"},{"text":"ldritch","obfuscated":true,"color":"dark_purple"},{"text":" superpower!"}]
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=BA] run tellraw @s ["",{"text":"You have gained a "},{"text":"E","color":"dark_purple"},{"text":"ld","obfuscated":true,"color":"dark_purple"},{"text":"r","color":"dark_purple"},{"text":"i","obfuscated":true,"color":"dark_purple"},{"text":"tch","color":"dark_purple"},{"text":" superpower!"}]
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=BB] run tellraw @s ["",{"text":"You have gained a "},{"text":"E","color":"dark_purple"},{"text":"l","obfuscated":true,"color":"dark_purple"},{"text":"dr","color":"dark_purple"},{"text":"i","obfuscated":true,"color":"dark_purple"},{"text":"t","color":"dark_purple"},{"text":"c","obfuscated":true,"color":"dark_purple"},{"text":"h","color":"dark_purple"},{"text":" superpower!"}]

tag @s remove A
tag @s remove AA
tag @s remove AB
tag @s remove BA
tag @s remove BB

## epic
execute if entity @s[tag=osp.rarity.epic] run particle minecraft:totem_of_undying ~ ~1 ~ 0 0 0 0.5 100
execute if entity @s[tag=osp.rarity.epic] run particle minecraft:explosion_emitter ~ ~1 ~
execute if entity @s[tag=osp.rarity.epic] run playsound minecraft:entity.wither.spawn master @a ~ ~ ~ 0.25 2 0.0125
execute if entity @s[tag=osp.rarity.epic] run tellraw @s ["",{"text":"You have gained a "},{"text":"Epic ","color":"gold"},{"text":"superpower!"}]

## rare
execute if entity @s[tag=osp.rarity.rare] run particle minecraft:totem_of_undying ~ ~1 ~ 0 0 0 0.5 50
execute if entity @s[tag=osp.rarity.rare] run playsound minecraft:entity.wither.spawn master @a ~ ~ ~ 0.25 2
execute if entity @s[tag=osp.rarity.rare] run tellraw @s ["",{"text":"You have gained a "},{"text":"Rare ","color":"aqua"},{"text":"superpower!"}]

## uncommon
execute if entity @s[tag=osp.rarity.uncommon] run particle minecraft:totem_of_undying ~ ~1 ~ 0 0 0 0.5 25
execute if entity @s[tag=osp.rarity.uncommon] run playsound minecraft:entity.wither.spawn player @a ~ ~ ~ 0.25 2
execute if entity @s[tag=osp.rarity.uncommon] run tellraw @s ["",{"text":"You have gained a "},{"text":"Uncommon ","color":"blue"},{"text":"superpower!"}]

## common
execute if entity @s[tag=osp.rarity.common] run particle minecraft:totem_of_undying ~ ~1 ~ 0 0 0 0.5 15
execute if entity @s[tag=osp.rarity.common] run playsound minecraft:entity.wither.spawn player @a ~ ~ ~ 0.25 2
execute if entity @s[tag=osp.rarity.common] run tellraw @s ["",{"text":"You have gained a "},{"text":"Common ","color":"green"},{"text":"superpower!"}]

tag @s add Done
# function run test
execute if score #TestStart function_run_count matches 0.. run scoreboard players add osp:systems/randomizer/join function_run_count 1
